/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GenObjects.c /main/7 1995/07/14 10:58:23 drk $"
#endif
#endif
/***********************************************************************
        @(#)GenObjects.c	1.5.1.1     Date:1/22/91
  	Author: TAT
	History:
            05/21/90 SJS Add tp sccs
            06/15/90 SJS fix propagation of events problem (call to 
                         mvsGetSubObjects()
            06/22/90 SJS Really do a depth first search to generate
	Calls:

	Summary:
            Generate the xis object hierarchy.

            INPUTS
                root_obj - Pointer to the root object

            OUTPUTS
                root_obj - Pointer to the root object with new hierarchy 

            RETURNS
                none
************************************************************************/

#include "mvslib.h"

void mvsGenerateObjects(root_obj)
XisObjectRecord *root_obj;
{
    MvsWidgetInfoRecord *winfo = mvsRootWidgetInfo->first_child;
    int stack_top=0;
    MvsWidgetInfoRecord *object_stack[50];

    /* Re-initialize next_avail_id_code to 0 */

    mvsGetSubObjects(NULL,NULL,0,0,False);

    /* Perform Depth-First Search */

    while (winfo != NULL) {

        if(!winfo->being_destroyed)
            mvsGetSubObjects(xisFindObjectFromWidget(winfo->parent->widget),
                                                     winfo->widget,0,0,False);

        if (winfo->first_child != NULL) {
            object_stack[stack_top++] = winfo;
            winfo = winfo->first_child;
        }
        else if (winfo->next_sibling != NULL) {
            winfo = winfo->next_sibling;
	}
        else {

            winfo = NULL;
            while (stack_top > 0 && winfo == NULL) {
                winfo = object_stack[--stack_top]->next_sibling;
            }
        }       
    }
} /* End mvsGenerateObjects() */
