%{
/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 */

#ifndef X_NOT_STDC_ENV
#include <stdlib.h>			/* For malloc prototype. */
#endif
#include <string.h>			/* For prototypes. */

#include "AutoToken.h"

#define		MAX_KEY_SIZE 512
int  pos, i, count;
char *yyscaleval;
extern char     *yystringval;           /* contains all string data */
extern char     *yyinputstring;         /* contains input string data */
extern int      yydigitval;             /* count info for Key and Button */
int	find_token;	/* Return value from AutoFindToken */

%}

DigitOrLetterOrUnder		[\-\~\/A-Za-z][\-\~\/a-zA-Z0-9$_]*
KeyWord				[A-Z][a-zA-Z0-9$]+
StringData			[ \-\~\/\\,\'\.\?\<\>\*\&\!\@\#\$\%\^\(\)A-Za-z0-9$_][ \-\~\/\\,\'\.\?\<\>\*\&\!\@\#\$\%\^\(\)a-zA-Z0-9$_]*
Digit				[0-9]


%%

[ \t\f\n]			{}
^#.*$				{}

\-?\.?{Digit}*			{ 
				/* Remove decimal point from value. Reasoning
				   is that Scale does not use floating point
				   values, rather the integer representation
				   of the float. */
				yyscaleval = (char *) malloc(sizeof(char) *
						            (yyleng + 1));
				if ((pos = strcspn((char *)yytext, ".")) != yyleng) {
				   count = 0;
				   for (i = 0 ; i < yyleng; i++)
					if (i != pos)
						yyscaleval[count++] = yytext[i];
				}
				else
					strcpy(yyscaleval, (char *)yytext);
				yydigitval = (int) atoi(yyscaleval);
				return(DIGIT); 
				}

\"{StringData}\"		{
				yyinputstring = (char *) malloc(sizeof(char) *
						               (yyleng + 1));
				strcpy(yyinputstring, (char *) yytext);
				return(ISTRING);
				}

\<{KeyWord}\>			|
{KeyWord}			{
				find_token = AutoFindToken((char*) yytext);
				if ( find_token == -1 ) {
					yystringval = (char *) malloc(
					sizeof(char) * (yyleng + 1));
					strcpy(yystringval, (char *) yytext);
					return(STRING);
				} else {
					return(find_token);
				}
				}

{DigitOrLetterOrUnder}		{
				yystringval = (char *) malloc(sizeof(char) * 
						             (yyleng + 1));
				strcpy(yystringval, (char *) yytext);
				return(STRING);
				}
%%
