/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: IsAncesObj.c /main/7 1995/07/14 11:35:57 drk $"
#endif
#endif
/***********************************************************************
  	@(#)IsAncesObj.c	1.4.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to sccs
	Calls:

	Summary:
            Determines if the first specified object is an ancestor of the 2nd.
        It returns true if this is in fact a true statement.

        INPUTS:
            object1 - object which may be ancestor of object2 
            object2 - any object
        
        OUTPUTS:
            none

        RETURNS:
            True if object1 is an ancestor of object2
            False otherwise
************************************************************************/
#include "xislib.h"

int xisIsAncestorObject(object1,object2)
XisObjectRecord  *object1,*object2;
{
    XisObjectRecord *tmp_object;

    if (object1 == NULL)
        return(False);

    if (object2 == NULL)
        return(False);

    tmp_object = object2;

    while (tmp_object != NULL && tmp_object != object1)
        tmp_object = tmp_object->parent;

    if (tmp_object == object1)
        return(True);
    else
        return(False);
} /* End xisIsAncestorObject */





