/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: IsPntrOver.c /main/7 1995/07/14 11:39:44 drk $"
#endif
#endif
/***********************************************************************
  	@(#)IsPntrOver.c	1.6.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/30/90 SJS add to sccs
            10/16/90 SJS check for ancestor relationship
	Calls:

	Summary:
            Returns True if pointer_obj matches specified object type.The object
	type passed in is a concatenation of the object types from the parent on
	down to the one we are interested in. Thus, from the keyboard region
	we go upwards from object to object. As we travel up the ancestor
	chain, each object type is compared against the corresponding "piece"
	of the concatenated type.

        INPUTS:
            none
        
        OUTPUTS:
            none

        RETURNS:
            True = pointer_obj is of specified type
            False = otherwise
************************************************************************/

#include <AutoMessages.h>
#include "xislib.h"

int xisIsPointerOverRegion(object_type_in)
int object_type_in;
{
    XisObjectRecord *object = xisInform.pointer_obj;
    int object_type, cum_object_type = object_type_in;
    int tmp;
    int succeed = 1;

    if (!xisInform.is_valid)
         AutoMessage(_AutoMessages[WARNMSG53]);

    if (object == NULL)
        return(FALSE);

    while (object != NULL && cum_object_type > 0) {

        tmp = cum_object_type / xisNumObjectTypes;
        object_type = cum_object_type - (tmp*xisNumObjectTypes);
     
        if (object->id.object_type != object_type) { /* Does not match */
            succeed = 0;
            break;
	}

        cum_object_type = tmp;
        object = object->parent;
    }

    /* This should be a straight equality */
    return (xisIsAncestorObject(xisInform.current_obj, object) && succeed);

} /* End xisIsPointerOverRegion() */
