/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: CheckVisual.c /main/8 1995/07/14 11:46:45 drk $"
#endif
#endif
/***********************************************************************
  	@(#)CheckVisual.c	1.5.1.1	Date:1/22/91
  	Author: TAT
	History:
            05/24/90 SJS add to SCCS
	Calls:

	Summary:
            Called to either compare the visual pixmap against known-good pixmap 
        record from file or to generate known-good pixmap. 

        INPUTS:
            widget - the widget whose image needs comparing or capturing
        
        OUTPUTS:
            none

        RETURNS:
            nothing
************************************************************************/
#include <AutoMessages.h>
#include "vislib.h"

void mvsCheckVisual(widget_info)
MvsWidgetInfoRecord *widget_info;
{

    char msg_string[125];
  
    if (XmIsGadget(widget_info->widget))
        widget_info = widget_info->parent;

    switch (mvsVisualMode) {
        case VISUAL_MODE_DONT_CHECK:
            mvsImageFd = 0;
            break;

        case VISUAL_MODE_BATCH_COMPARE:
            mvsComparePixmapBatch(widget_info);
            break;

        case VISUAL_MODE_INTERACTIVE_COMPARE:
	    mvsComparePixmapInt(widget_info);
            break;

        case VISUAL_MODE_GENERATE_PIXMAPS:
            mvsGeneratePixmap(widget_info);
            break;        

	default:
	    sprintf(msg_string, _AutoMessages[VISMSG45], mvsVisualMode);
	    AutoMessage(msg_string);
    }

} /* End mvsCheckVisual() */
