/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: ColorCache.c /main/7 1995/07/14 11:48:38 drk $"
#endif
#endif
/***********************************************************************
  	@(#)ColorCache.c	1.2.1.1	Date:1/22/91
  	Author: PSN
	History:
	   11/12/90 PSN Add to sccs tree
	Calls:

	Summary:
            This file contains the function visLookUpColorCache &
	visAddToColorCache which looks-up local color cache for 
	existance of already looked up pixel, if present use the cache
	value otherwise do XQueryColor for the given pixel and save that
	XColor returned.
	      
        INPUTS
            Pointer to XColor that contains correct pixel value for 
	visLookUpColorCache & visAddToColorCache; but also contains
	other fields correctly initialized for visAddToColorCache.

        OUTPUTS
            XColor initialized by visLookUpColorCache.
	    Cache updated by visAddToColorCache.
 
        RETURNS
            <0 failed, >=0 succeeded for visLookUpColorCache.
************************************************************************/

#include <AutoMessages.h>
#include "vislib.h"

int visLookUpColorCache(color)
XColor	*color;
{
    int	   i;
    Pixel  pixel = color->pixel;

    for (i=0; i<cache_pointer && i<MAX_COLORS; i++)
	if (color_cache[i].pixel == pixel) {
	   *color = color_cache[i];
	   return (i);
	}
    return(-1);

} /* End visLookUpColorCache() */

void visAddToColorCache(color)
XColor	*color;
{
    if (cache_pointer < MAX_COLORS)
	color_cache[cache_pointer++] = *color;
    else
      AutoMessage(_AutoMessages[WARNMSG60]);

} /* End visAddToColorCache() */

/* 
 * Clear cache pointer so that it effectively clears the color cache
 */
void visClearColorCache()
{
    cache_pointer = 0;
} /* End visClearColorCache() */



