/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
#ifdef REV_INFO
#ifndef lint
static char rcsid[] = "$XConsortium: GetCharSet.c /main/7 1995/07/14 11:50:14 drk $"
#endif
#endif
/***********************************************************************
  	@(#)GetCharSet.c	1.7.1.1	Date:1/22/91
  	Author: TAT
	History:
            07/31/90 SJS change arg to char pointer, some msg changes
	Calls:

	Summary:
            This function tries to select the most appropriate XmString
            char set given that the user requests one specific char set.
            If for some reason this request can't be satisfied, it returns
            a more appropriate char set.

************************************************************************/

#include <AutoMessages.h>
#include "mvslib.h"

XmStringCharSet mvsGetCharSet(requested_char_set)
char *requested_char_set;
{
    int i;
    char msg_string[125];

    if (mvsNumLoadedFonts == 0)
        return XmSTRING_DEFAULT_CHARSET;

    for (i=0; i < mvsNumFonts; i++) {

        if (strcmp(requested_char_set,mvsFontInfo[i].char_set_name) == 0)
            break;
    }

    if (i == mvsNumLoadedFonts) {
       sprintf(msg_string, _AutoMessages[VISMSG38], requested_char_set,mvsFontInfo[0].char_set_name);
       AutoMessage(msg_string);
                    
        i = 0;
    }

    if ((i < mvsNumFonts) && (mvsFontInfo[i].font_struct == NULL)) {
        sprintf (msg_string, _AutoMessages[VISMSG39], requested_char_set);
	AutoMessage(msg_string);
                    
        for (i=0; i<mvsNumFonts; i++) {
            if (mvsFontInfo[i].font_struct != NULL)
                break;
        }
        if (i == mvsNumFonts)
            return XmSTRING_DEFAULT_CHARSET;
    }

    return(mvsFontInfo[i].char_set_name);

} /* End mvsGetCharSet() */
