/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
*/ 
/*   $XConsortium: ABrowse.h /main/8 1995/07/14 10:45:01 drk $ */

/**********************************************************
 * ABrowse.h: Public header file for ABrowse Widget Class *
 **********************************************************/

#ifndef _ABrowse_h
#define _ABrowse_h

#include <X11/Constraint.h>

/* Parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 buttonBackground    Background		Pixel		White
 buttonForeground    Foreground		Pixel		Black
 defaultDistance     Thickness		int		4
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	computed at realize
 helpCallback	     Callback		Pointer		NULL
 imageBackground     Background		Pixel		White
 imageForeground     Foreground		Pixel		Black
 images		     Images		Pointer		NULL
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 numImages	     NumImages		Int		0
 quitCallback	     Callback		Pointer		NULL
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	computed at realize
 x		     Position		Position	0
 y		     Position		Position	0

*/

/* Constraint parameters:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 bottom		     Edge		XtEdgeType	XtRubber
 fromHoriz	     Widget		Widget		(left edge of form)
 fromVert	     Widget		Widget		(top of form)
 horizDistance	     Thickness		int		defaultDistance
 left		     Edge		XtEdgeType	XtRubber
 resizable	     Boolean		Boolean		False
 right		     Edge		XtEdgeType	XtRubber
 top		     Edge		XtEdgeType	XtRubber
 vertDistance	     Thickness		int		defaultDistance

*/

#define XtNimages		"images"
#define XtNnumImages		"numImages"
#define XtNimageBackground	"imageBackground"
#define XtNimageForeground	"imageForeground"
#define XtNbuttonBackground	"buttonBackground"
#define XtNbuttonForeground	"buttonForeground"
#define XtNhelpCallback		"helpCallback"
#define XtNquitCallback		"quitCallback"

#define XtCImages		"Images"
#define XtCNumImages		"NumImages"

typedef struct _ABrowseClassRec	*ABrowseWidgetClass;
typedef struct _ABrowseRec	*ABrowseWidget;

extern WidgetClass		abrowseWidgetClass;

extern Widget			XtCreateABrowse();

#endif _ABrowse_h
