/* $XConsortium: CxxManager.cxx /main/4 1995/07/17 11:46:08 drk $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */

extern "C" {
#include <testlib.h>
};
#include <sys/file.h>

/*  Standard C headers  */
#include <stdio.h>
#include <stdlib.h>

/* C++ headers */ 
#include <iostream.h>

/*  X headers  */
#include <X11/IntrinsicP.h>

/*  Xm headers  */
#include <Xm/Xm.h>
#include <Xm/PushBG.h>
#include <ExmCxx/CxxGrid.h>

// These are used to indicate that the associated method has been
// invoked for coverage analysis.

unsigned char initializeCount = 0;
unsigned char resizeCount = 0;
unsigned char exposeCount = 0;
unsigned char set_valuesCount = 0;
unsigned char query_geometryCount = 0;
unsigned char geometry_managerCount = 0;
unsigned char change_managedCount = 0;
unsigned char constraint_initializeCount = 0;
unsigned char constraint_destroyCount = 0;
unsigned char constraint_set_valuesCount = 0;
unsigned char layoutCount = 0;
unsigned char calc_sizeCount = 0;

// This test doesn't do much.  A few resources a played with so that
// some of the XmCxxSimple class methods are excersized.

int main(int argc, char** argv)
{

  Widget	mainWindow, gridWidget1;
  Widget        b;
  Arg		args[10];
  int		n;

  CommonTestInit(argc, argv);

  mainWindow = XtCreateManagedWidget("myMainWindow", xmMainWindowWidgetClass, 
				     Shell1, NULL, 0);

  n = 0;
  XtSetArg(args[n], XmNrows, 2); n++;
  XtSetArg(args[n], XmNcolumns, 2); n++;

  gridWidget1 = ExmCreateCxxGrid( mainWindow, "myCxxGrid", args, n);

  XtManageChild(XmCreatePushButton(gridWidget1, "Button1", NULL, 0));
  XtManageChild(XmCreatePushButton(gridWidget1, "Button2", NULL, 0));
  XtManageChild(b = XmCreatePushButton(gridWidget1, "Button3", NULL, 0));
  XtManageChild(XmCreatePushButton(gridWidget1, "Button4", NULL, 0));
  XtManageChild(gridWidget1);

  XmMainWindowSetAreas(mainWindow, NULL, NULL, NULL, NULL, gridWidget1);

  XtRealizeWidget(Shell1);

  CommonPause();

  n = 0;
  XtSetArg(args[n], XmNrows, 1); n++;
  XtSetArg(args[n], XmNcolumns, 4); n++;
  XtSetValues(gridWidget1, args, n);

  CommonPause();

  XtDestroyWidget( b );

  cout << "		COVERAGE REPORT\n"
       << "             ---------------\n"
       << "ExmCxxGrid::initialize "
       << (initializeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::resize "
       << (resizeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::expose "
       << (exposeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::set_values "
       << (set_valuesCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::query_geometry "
       << (query_geometryCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::geometry_manager "
       << (geometry_managerCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::change_managed "
       << (change_managedCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::constraint_initialize "
       << (constraint_initializeCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::constraint_destroy "
       << (constraint_destroyCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::constraint_set_values "
       << (constraint_set_valuesCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::layout "
       << (layoutCount ? "was" : "was not") << " invoked.\n"
       << "ExmCxxGrid::calc_size "
       << (calc_sizeCount ? "was" : "was not") << " invoked.\n" << flush ;

  CommonPause();

  XtAppMainLoop(app_context);
}
